Index: unk/Makefile
===================================================================
--- /trunk/Makefile	(revision 10)
+++ 	(revision )
@@ -1,466 +1,0 @@
-####################################################################
-###                                                              ###
-###             Makefile pour  LaTeX                             ###
-###                                                              ###
-####################################################################
-#
-# Copyright 2000-2011 Gabriel Moreau / Vincent Morra
-
-# Il y a encore pas mal de bug dans ce makefile
-# génération du these.ps -> des merdouilles au niveau
-# des figures. Solution: aller sous tmp/ et dvips à la main
-
-# General configuration
-# Put your change only in config.mk file
-################################################################
-
-QUIX := A.linux
-
-DOCUMENT := document
-
-ARBO_TEX := ./
-ARBO_FIG := $(ARBO_TEX)
-ARBO_BIB := $(ARBO_TEX)
-
-################################################################
-
-DIR_PROJET := $(shell pwd | perl -p -e 's!/src/?.*$!!!' )
-DIR_TMP    := $(DIR_PROJET)/tmp
-DIR_DOC    := $(DIR_PROJET)/doc
-DIR_PS     := $(DIR_DOC)/ps
-DIR_PDF    := $(DIR_DOC)/pdf
-DIR_HTML   := $(DIR_DOC)/html
-
-################################################################
-
-LATEX         := latex
-BIBTEX        := bibtex
-L2H           := latex2html
-PDFTEX        := pdflatex
-DVIPS         := dvips 
-RM            := rm -f
-BIN_PROTECT   := chmod u-w .
-BIN_UNPROTECT := chmod u+w .
-
-DVI_EDITOR := export XEDITOR="vim --servername DOC --remote +%l %f"
-DVI_EDITOR := export XEDITOR="vim +%l %f"
-DVI_EDITOR := export XEDITOR="nedit-nc -line %l %f"
-
-DVI_VIEWER := xdvi
-PDF_VIEWER := xpdf
-PS_VIEWER  := gv
-
-
-# User Config
-################################################################
-
-sinclude config.mk
-
-# NE PAS TOUCHER A PARTIR D'ICI
-################################################################
-
-SRC_FIG     := $(notdir $(foreach dir,$(ARBO_FIG),$(wildcard $(dir)/*.fig)))
-SRC_EPS     := $(notdir $(foreach dir,$(ARBO_FIG),$(wildcard $(dir)/*.eps)))
-SRC_PDF     := $(notdir $(foreach dir,$(ARBO_FIG),$(wildcard $(dir)/*.pdf)))
-SRC_JPG     := $(notdir $(foreach dir,$(ARBO_FIG),$(wildcard $(dir)/*.jpg)))
-SRC_PNG     := $(notdir $(foreach dir,$(ARBO_FIG),$(wildcard $(dir)/*.png)))
-SRC_GIF     := $(notdir $(foreach dir,$(ARBO_FIG),$(wildcard $(dir)/*.gif)))
-SRC_TEX     := $(notdir $(foreach dir,$(ARBO_TEX),$(wildcard $(dir)/*.tex)))
-SRC_BIB     := $(notdir $(foreach dir,$(ARBO_BIB),$(wildcard $(dir)/*.bib)))
-
-OBJ_FIG2EPS      := $(patsubst %.fig,$(DIR_TMP)/%.eps,      $(SRC_FIG))
-OBJ_FIG2PSTEX_T  := $(patsubst %.fig,$(DIR_TMP)/%.pstex_t,  $(SRC_FIG))
-OBJ_FIG2PDF      := $(patsubst %.fig,$(DIR_TMP)/%.pdf,      $(SRC_FIG))
-OBJ_FIG2PDFTEX_T := $(patsubst %.fig,$(DIR_TMP)/%.pdftex_t, $(SRC_FIG))
-OBJ_EPS2PDF      := $(patsubst %.eps,$(DIR_TMP)/%.pdf,      $(SRC_EPS))
-OBJ_JPG2EPS      := $(patsubst %.jpg,$(DIR_TMP)/%.eps,      $(SRC_JPG))
-OBJ_PNG2EPS      := $(patsubst %.png,$(DIR_TMP)/%.eps,      $(SRC_PNG))
-OBJ_GIF2EPS      := $(patsubst %.gif,$(DIR_TMP)/%.eps,      $(SRC_GIF))
-
-OBJ_BASE    := $(DIR_TMP)/$(DOCUMENT)
-
-TEXINPUTS   := $(subst //,/,$(subst / /,:/,$(foreach dir,$(ARBO_TEX) $(ARBO_FIG),$(strip $(DIR_PROJET)/src/$(dir)/)))):$(DIR_TMP):
-BIBINPUTS   := $(subst //,/,$(subst / /,:/,$(foreach dir,$(ARBO_BIB),$(strip $(DIR_PROJET)/src/$(dir)/))))
-
-PDFTEXPRE   := export TEXMFOUTPUT="$(DIR_TMP)";
-PDFTEXPRE   += export TEXINPUTS="$(TEXINPUTS)";
-PDFTEXPRE   += export LANG="C";
-
-BIBTEXPRE   := cd $(DIR_TMP);
-BIBTEXPRE   += BIBINPUTS="$(BIBINPUTS)"
-BIBTEXPRE   += BSTINPUTS="$(BIBINPUTS)"
-
-RERUNTEX := "(There were undefined references|Rerun to get (cross-references|the bars) right)"
-RERUNBIB := "No file.*\.bbl|Citation.*undefined" 
-
-COPYTOC := if test -r $(OBJ_BASE).toc; then cp $(OBJ_BASE).toc $(OBJ_BASE).toc.bak; fi 
-
-vpath %.fig       $(ARBO_FIG)
-vpath %.pstex     $(DIR_TMP)
-vpath %.pstex_t   $(DIR_TMP)
-vpath %.pdftex    $(DIR_TMP)
-vpath %.pdftex_t  $(DIR_TMP)
-vpath %.pdf       $(ARBO_FIG) $(DIR_TMP)
-vpath %.eps       $(ARBO_FIG) $(DIR_TMP)
-vpath %.jpg       $(ARBO_FIG)
-vpath %.png       $(ARBO_FIG)
-vpath %.gif       $(ARBO_FIG)
-vpath %.bib       $(ARBO_BIB)
-
-.PHONY: all folder
-.PHONY: doc docps docpdf
-.PHONY: html
-.PHONY: xpdf xdvi gv
-.PHONY: vims vimc
-.PHONY: echo clean miniclean help
-.PHONY: figure bibtex
-.PHONY: pdflatex pdf  
-.PHONY: latex    dvi
-.PHONY: protect unprotect
-.PHONY: warning review
-.SUFFIXES:
-
-#--------------------------------------------------------------#
-
-all: folder doc
-
-folder: $(DIR_HTML) $(DIR_PS) $(DIR_PDF) $(DIR_TMP)
-	@echo '############################################################'
-	@echo '### Fin de la gestion des dossiers'
-	@echo '############################################################'
-
-#--------------------------------------------------------------#
-
-xpdf: $(DIR_TMP)/$(DOCUMENT).pdf
-	$(PDF_VIEWER) $(DIR_TMP)/$(DOCUMENT).pdf &
-	@echo '############################################################'
-	@echo '####  Visualisation de $(DOCUMENT)'
-	@echo '############################################################'
-
-xdvi: $(DIR_TMP)/$(DOCUMENT).dvi
-	$(DVI_EDITOR); \
-	$(DVI_VIEWER) -bg grey95 $(DIR_TMP)/$(DOCUMENT) &
-	@echo '############################################################'
-	@echo '####  Visualisation de $(DOCUMENT)'
-	@echo '############################################################'
-#	xdvi -hl white $(DIR_TMP)/$(DOCUMENT) &
-
-gv:$(DIR_PS)/$(DOCUMENT).ps 
-	$(PS_VIEWER) $(DIR_PS)/$(DOCUMENT).ps &
-	@echo '############################################################'
-	@echo '####  Visualisation de $(DOCUMENT)'
-	@echo '############################################################'
-
-#--------------------------------------------------------------#
-
-vims:
-	vim --servername DOC $(DOCUMENT).tex
-
-vimc:
-	@echo alias vi=\'vim --servername DOC --remote\'
-
-#--------------------------------------------------------------#
-
-doc: docpdf docps
-	@echo '############################################################'
-	@echo '### Fin de la compilation '
-	@echo '############################################################'
-
-docpdf: $(DIR_PDF)/$(DOCUMENT).pdf
-	@echo '############################################################'
-	@echo '### Fin de la doc pdf'
-	@echo '############################################################'
-
-docps: $(DIR_PS)/$(DOCUMENT).ps 
-	@echo '############################################################'
-	@echo '### Fin de la doc postscript'
-	@echo '############################################################'
-
-html: $(DIR_HTML)
-	$(L2H) -split 3 -local_icons -no_math -white \
-        -tmp /tmp -dir $(DIR_HTML) -prefix $(DOCUMENT) -antialias $(DOCUMENT).tex
-
-#--------------------------------------------------------------#
-
-warning:
-	@echo '############################################################'
-	@echo '### Liste des warnings dans le documents'
-	@echo '############################################################'
-#	@touch -r $(DOCUMENT).tex $(DIR_TMP)/warning.log
-#	@touch -r $(DIR_TMP)/warning.log
-#	@touch $(DOCUMENT).tex
-	@make pdflatex | grep Warning | grep -v Marginpar
-#	@touch  -r $(DIR_TMP)/warning.log $(DOCUMENT).tex
-#	@touch -r $(DIR_TMP)/warning.log 
-
-review:
-	@echo '############################################################'
-	@echo "### Liste des `grep -HnE '\\rev(add|del|mark|par|forget)' -r . | grep -E '^*/.*\.tex\:' | grep -v macro_review.tex | wc -l` reviews dans le documents"
-	@echo '############################################################'
-	@grep -HnE '\\rev(add|del|mark|par|forget)' -r . | grep -E '^*/.*\.tex\:' | grep -v macro_review.tex
-
-#--------------------------------------------------------------#
-
-echo: 
-	@echo '############################################################'
-	@echo '### Liste des variables '
-	@echo '############################################################'
-	@echo SRC_FIG         $(SRC_FIG)
-	@echo SRC_TEX         $(SRC_TEX)
-	@echo OBJ_PSTEX       $(OBJ_PSTEX)
-	@echo OBJ_FIG2PSTEX_T $(OBJ_FIG2PSTEX_T)
-	@echo OBJ_EPS2PDF     $(OBJ_EPS2PDF)
-	@echo OBJ_FIG2PDF     $(OBJ_FIG2PDF)
-
-clean: 
-	@echo '############################################################'
-	@echo '####  Nettoyage'
-	@echo '############################################################'
-	$(RM) $(DOCUMENT).aux \
-        $(DOCUMENT).log \
-        $(DOCUMENT).bbl \
-        $(DOCUMENT).blg \
-        $(DOCUMENT).brf \
-        $(DOCUMENT).cb  \
-        $(DOCUMENT).ind \
-        $(DOCUMENT).idx \
-        $(DOCUMENT).ilg \
-        $(DOCUMENT).dvi \
-        $(DOCUMENT).inx \
-        $(DOCUMENT).toc \
-        $(DOCUMENT).out \
-        $(DOCUMENT).lof \
-        $(DOCUMENT).lot \
-        $(DOCUMENT).pdf \
-        $(OBJ_PSTEX) \
-        $(OBJ_FIG2PSTEX_T) \
-        $(OBJ_FIG2PDF) \
-        $(DIR_PDF)/$(DOCUMENT).pdf \
-        $(DIR_TMP)/*
-
-miniclean: 
-	@echo '############################################################'
-	@echo '####  Nettoyage tres partiel'
-	@echo '############################################################'
-	$(RM)   $(DIR_TMP)/$(DOCUMENT).aux \
-	        $(DIR_TMP)/$(DOCUMENT).toc \
-	        $(DIR_TMP)/$(DOCUMENT).lof
-
-#--------------------------------------------------------------#
-
-figure: $(OBJ_FIG2PDF) $(OBJ_FIG2PDFTEX_T) $(OBJ_FIG2EPS) $(OBJ_FIG2PSTEX_T)
-	@echo '############################################################'
-	@echo '####  Fin des figures'
-	@echo '############################################################'
-
-#--------------------------------------------------------------#
-
-protect:
-	$(BIN_PROTECT)
-	@echo '############################################################'
-	@echo '#### Mise en place de la protection du dossier source'
-	@echo '############################################################'
-
-unprotect:
-	$(BIN_UNPROTECT)
-	@echo '############################################################'
-	@echo '#### Suppression de la protection du dossier source'
-	@echo '############################################################'
-
-#--------------------------------------------------------------#
-
-pdflatex: folder figure $(OBJ_EPS2PDF)
-	@echo '############################################################'
-	@echo '####  Debut du formateur pdflatex'
-	@echo '############################################################'
-	$(BIN_PROTECT)
-	$(PDFTEXPRE) $(PDFTEX) $(DOCUMENT).tex; true
-	$(BIN_UNPROTECT)
-	@echo '############################################################'
-	@echo '####  Fin du formateur pdflatex'
-	@echo '############################################################'
-
-latex: folder figure $(OBJ_JPG2EPS) $(OBJ_PNG2EPS) $(OBJ_GIF2EPS)
-	@echo '############################################################'
-	@echo '####  Debut du formateur latex'
-	@echo '############################################################'
-	$(BIN_PROTECT)
-	$(PDFTEXPRE) $(LATEX) -src $(DOCUMENT).tex; true
-	$(BIN_UNPROTECT)
-	@echo '############################################################'
-	@echo '####  Fin du formateur latex'
-	@echo '############################################################'
-
-bibtex:
-	@echo '############################################################'
-	@echo '####  Debut de la bibliographie'
-	@echo '############################################################'
-	$(BIBTEXPRE) $(BIBTEX) $(OBJ_BASE)
-	@echo '############################################################'
-	@echo '####  Fin de la bibliographie'
-	@echo '############################################################'
-
-#--------------------------------------------------------------#
-
-help:
-	@echo '############################################################'
-	@echo '# all       -> compilation complete'
-	@echo '# folder    -> création des dossiers du projet'
-	@echo '# clean     -> nettoyage partiel'
-	@echo '# pdf       -> compilation simple avec dependance -> pdf'
-	@echo '# dvi       -> compilation simple avec dependance -> dvi'
-	@echo '# xpdf      -> visualisation du resultat pdf'
-	@echo '# xdvi      -> visualisation du resultat dvi'
-	@echo '# gv        -> visualisation du resultat ps'
-	@echo '# warning   -> liste de tous les warnings'
-	@echo '# review    -> liste de toutes les remarques'
-	@echo '# pdflatex  -> compilation du source tex -> pdf'
-	@echo '# latex     -> compilation du source tex -> dvi'
-	@echo '# bibtex    -> compilation du source bibtex'
-	@echo '# protect   -> protection du dossier source'
-	@echo '# unprotect -> suppression de la protection'
-	@echo '############################################################'
-
-#--------------------------------------------------------------#
-
-pdf: $(DIR_TMP)/pdf.ok
-
-dvi: $(DIR_TMP)/dvi.ok
-
-$(DIR_TMP)/pdf.ok: $(DOCUMENT).tex $(SRC_TEX) $(OBJ_FIG2PDF) $(OBJ_FIG2PDFTEX_T)
-	make pdflatex
-	touch $<
-
-$(DIR_TMP)/dvi.ok: $(DOCUMENT).tex $(SRC_TEX) $(OBJ_FIG2EPS) $(OBJ_FIG2PSTEX_T)
-	make latex
-	touch $<
-
-################################################################
-
-$(DIR_TMP)/$(DOCUMENT).pdf: $(DOCUMENT).tex $(SRC_BIB) $(SRC_TEX) $(OBJ_FIG2PDF) $(OBJ_FIG2PSTEX_T)
-	$(COPYTOC)
-	make pdflatex
-	egrep -c $(RERUNBIB) $(OBJ_BASE).log && (make bibtex;$(COPYTOC); make pdflatex); true
-	egrep $(RERUNTEX) $(OBJ_BASE).log    && ($(COPYTOC); make pdflatex); true
-	egrep $(RERUNTEX) $(OBJ_BASE).log    && ($(COPYTOC); make pdflatex); true
-	if cmp -s $(OBJ_BASE).toc $(OBJ_BASE).toc.bak; then echo 'end'; else make pdflatex; fi
-	$(RM) $(OBJ_BASE).toc.bak
-#	egrep -i "(Reference|Citation).*undefined" $(OBJ_BASE).log; true
-# Display relevant warnings
-
-################################################################
-
-################################################################
-
-$(DIR_TMP)/$(DOCUMENT).dvi: $(DOCUMENT).tex $(SRC_BIB) $(SRC_TEX) $(OBJ_FIG2EPS) $(OBJ_FIG2PSTEX_T)
-	$(COPYTOC)
-	make latex
-	egrep -c $(RERUNBIB) $(OBJ_BASE).log && (make bibtex;$(COPYTOC); make latex); true
-	egrep $(RERUNTEX) $(OBJ_BASE).log    && ($(COPYTOC); make latex); true
-	egrep $(RERUNTEX) $(OBJ_BASE).log    && ($(COPYTOC); make latex); true
-	if cmp -s $(OBJ_BASE).toc $(OBJ_BASE).toc.bak; then echo 'end'; else make latex; fi
-	$(RM) $(OBJ_BASE).toc.bak
-#	egrep -i "(Reference|Citation).*undefined" $(OBJ_BASE).log; true
-# Display relevant warnings
-
-################################################################
-
-#$(DIR_PS)/%.ps: $(DIR_PDF)/%.pdf
-#	pdftops $< $@
-
-
-$(DIR_PS)/%.ps: $(DIR_TMP)/%.dvi 
-	$(PDFTEXPRE) 
-	dvips $< -o $@
-
-$(DIR_PDF)/%.pdf: $(DIR_TMP)/%.pdf
-	echo ---
-	rm -f $@
-	echo ---
-	cp $< $@
-#	ln -f $< $@
-#       je sais pas pourquoi mais le lien ne marche pas bien avec le make
-
-################################################################
-# figure
-
-#$(DIR_TMP)/%.pdf: $(DIR_TMP)/%.pstex $(DIR_TMP)/%.pstex_t
-#	ps2pdf  $<  $@
-#	cd $(DIR_TMP); \
-#	sed 's/\.pstex/.pdf/' $*.pstex_t > $*.tmp; \
-#	mv $*.tmp $*.pstex_t; \
-#	sed 's/\\epsfig{file=/\\includegraphics{/' $*.pstex_t > $*.tmp; \
-#	mv $*.tmp $*.pstex_t  
-
-$(DIR_TMP)/%.pstex: %.fig
-	fig2dev -L pstex $< $@
-
-$(DIR_TMP)/%.eps: %.fig
-	fig2dev -L pstex $< $@
-
-$(DIR_TMP)/%.pstex_t: %.fig $(DIR_TMP)/%.pstex
-	fig2dev -L pstex_t -p $* $< $@
-#	fig2dev -L pstex_t -E 1 -p $* $< $@
-
-#$(DIR_TMP)/%.pstex_t: $(DIR_TMP)/%.pstex %.fig 
-#	fig2dev -L pstex_t -p $^ $@
-
-ifeq "$(QUIX)" "A.linux"
-$(DIR_TMP)/%.pdftex: %.fig
-	fig2dev -L pdftex $< $@
-endif
-ifeq "$(QUIX)" "A.darwin"
-$(DIR_TMP)/%.pdftex: %.fig
-	fig2dev -L pstex $< $(patsubst %.pdftex,%.pstex,$@)
-	ps2pdf $(patsubst %.pdftex,%.pstex,$@)  $@
-endif
-
-ifeq "$(QUIX)" "A.linux"
-$(DIR_TMP)/%.pdf: %.fig
-	fig2dev -L pdftex $< $@
-endif
-ifeq "$(QUIX)" "A.darwin"
-$(DIR_TMP)/%.pdf: %.fig
-	fig2dev -L pstex $< $(patsubst %.pdf,%.eps,$@)
-	ps2pdf $(patsubst %.pdf,%.eps,$@)  $@
-endif
-
-$(DIR_TMP)/%.pdftex_t: %.fig $(DIR_TMP)/%.pdftex
-	fig2dev -L pdftex_t -p $* $< $@
-#	fig2dev -L pdftex_t -E 1 -p $* $< $@
-
-
-$(DIR_TMP)/%.pdf: %.eps
-	epstopdf $< --outfile $@
-
-$(DIR_TMP)/%.eps: %.jpg
-	convert $< $@
-
-$(DIR_TMP)/%.eps: %.png
-	convert $< $@
-
-$(DIR_TMP)/%.eps: %.gif
-	convert $< $@
-
-################################################################
-# dossier
-
-$(DIR_DOC):
-	mkdir -p $@
-	chmod ugo+rx $@
-
-$(DIR_TMP):
-	mkdir -p $@
-	chmod ugo+rwx $@
-
-$(DIR_PS): $(DIR_DOC)
-	mkdir -p $@
-	chmod ugo+rx $@
-
-$(DIR_PDF): $(DIR_DOC)
-	mkdir -p $@
-	chmod ugo+rx $@
-
-$(DIR_HTML): $(DIR_DOC)
-	mkdir -p $@
-	chmod ugo+rx $@
Index: unk/review.sty
===================================================================
--- /trunk/review.sty	(revision 10)
+++ 	(revision )
@@ -1,321 +1,0 @@
-
-\NeedsTeXFormat{LaTeX2e}[1999/01/01]
-\ProvidesPackage{review}[2004/02/17]
-\RequirePackage{color,keyval,twoopt}
-
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-% Copyright 2004-2011 Gabriel Moreau                                     %
-%                                                                        %
-% This work may be distributed and/or modified under the                 %
-% conditions of the LaTeX Project Public License, either version 1.3     %
-% of this license or (at your option) any later version.                 %
-% The latest version of this license is in                               %
-%   http://www.latex-project.org/lppl.txt                                %
-% and version 1.3 or later is part of all distributions of LaTeX         %
-% version 2005/12/01 or later.                                           %
-%                                                                        %
-% This work has the LPPL maintenance status `maintained'.                %
-%                                                                        %
-% The Current Maintainer of this work is G. Moreau.                      %
-%                                                                        %
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-% Pour gérer les deux types d'options :                                  %
-%  1. les options normales (\DeclareOption{...}{...})                    %
-%  2. les options type key-val option=value (\define@key{...}{...}{...}) %
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-\@ifundefined{rev@unusedlist}{%
-  \let\rev@unusedlist\@empty}{}
-\@ifundefined{rev@extractkey}{%
-  \def\rev@extractkey#1=#2\rev@extractkey{#1}}{}
-\newcommand{\ProcessUnusedOptions}[1]{%
-  \let\my@tempa\@empty
-  \let\my@tempb\@empty
-  \@for\CurrentOption:=\rev@unusedlist\do{%
-    \expandafter\expandafter\expandafter\def
-    \expandafter\expandafter\expandafter\my@key
-    \expandafter\expandafter\expandafter{%
-      \expandafter\rev@extractkey\CurrentOption=\rev@extractkey}%
-    \@ifundefined{KV@#1@\my@key}{%
-      \edef\my@tempa{\my@tempa,\CurrentOption,}}{%
-      \edef\my@tempb{\my@tempb,\CurrentOption,}}}%
-  \@for\CurrentOption:=\my@tempa\do{%
-    \ifx\CurrentOption\@empty\else
-      \PackageWarning{review}{`\CurrentOption' not defined.}\fi}%
-  \edef\my@tempb{%
-    \noexpand\setkeys{#1}{\my@tempb}}%
-  \my@tempb
-  \AtEndOfPackage{\let\@unprocessedoptions\relax}}
-
-\DeclareOption*{%
-  \expandafter\expandafter\expandafter\def
-  \expandafter\expandafter\expandafter\rev@unusedlist
-  \expandafter\expandafter\expandafter{%
-    \expandafter\rev@unusedlist\expandafter,%
-    \CurrentOption}}
-
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-% initialisation
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-
-\newif\if@rev@see \@rev@seetrue
-\newlength{\rev@len}
-\setlength{\rev@len}{\marginparwidth}
-\addtolength{\rev@len}{-0.5cm}
-\newcounter{rev@counter}
-\definecolor{rev@colortext}{rgb}{1,0,0}
-\definecolor{rev@colormark}{rgb}{0,0,1}
-
-\def\rev@contextwait{wait}
-\def\rev@contextreject{reject}
-\def\rev@contextaccept{accept}
-
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-% options
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-
-%% Options «normales»
-\DeclareOption{draft}{\@rev@seetrue}
-\DeclareOption{see}{\@rev@seetrue}
-\DeclareOption{hide}{\@rev@seefalse}
-\DeclareOption{final}{\@rev@seefalse}
-
-%% Options passées sous forme key=val
-\define@key{review}{width}{\setlength{\rev@len}{#1}}
-\define@key{review}{counter}{\setcounter{rev@counter}{#1}}
-%\define@key{review}{colortext}{\definecolor{rev@colortext}{rgb}{#1}}
-%\define@key{review}{colormark}{\definecolor{rev@colormark}{rgb}{#1}}
-%\define@key{mypack}{<key2>}[<default>]{<action 2> dépendant de #1}
-
-\ProcessOptions
-\ProcessUnusedOptions{review}
-
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-% internal command
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-
-% #1 command
-\newcommand{\rev@error}[1]{%
-   \PackageError{review}{option for #1 are 'accept' 'reject' or 'wait'}%
-   }
-
-% #1 author
-% #2 type
-% #3 other thing (with \\\hline please)
-\newcommand{\rev@notewait}[3]{%
-   \marginpar{%
-   \begin{tabular}{|p{\rev@len}|}\hline%
-   \texttt{\textcolor{#1}{\textcolor{rev@colormark}{\therev@counter{#2}}-#1}}\\\hline%
-   #3%
-   \end{tabular}%
-   }}
-
-% #1 author
-% #2 type
-\newcommand{\rev@noteaccept}[2]{%
-   \marginpar{%
-   $\left<\texttt{\textcolor{#1}{\textcolor{rev@colormark}{\therev@counter{#2}}-#1}}\right>$%
-   }}
-
-% #1 author
-% #2 type
-\newcommand{\rev@notereject}[2]{%
-   \marginpar{%
-   $\left/\texttt{\textcolor{#1}{\textcolor{rev@colormark}{\therev@counter{#2}}-#1}}\right/$%
-   }}
-
-% #1 author
-% #2 type
-\newcommand{\rev@notemark}[2]{%
-   \textcolor{#1}{$^{\left<\texttt{\textcolor{rev@colormark}{\therev@counter{#2}}}\right>}$}%
-   }
-
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-% external command
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-
-% #1 author
-% #2 color
-\newcommand{\revauthor}[2]{\definecolor{#1}{rgb}{#2}}
-
-% #1 color
-\newcommand{\revcolortext}[1]{\definecolor{rev@colortext}{rgb}{#1}}
-
-% #1 color
-\newcommand{\revcolormark}[1]{\definecolor{rev@colormark}{rgb}{#1}}
-
-
-% [#1] context
-% [#2] null
-%  #3  author
-%  #4  add
-%  #5  com
-\newcommandtwoopt{\revadd}[5][wait][null]{%
-   \def\rev@contextlocal{#1}%
-   \stepcounter{rev@counter}%
-   \if@rev@see%
-      \ifx\rev@contextlocal\rev@contextwait%
-         \textcolor{rev@colortext}{#4}%
-         \rev@notemark{#3}{a}%
-         \rev@notewait{#3}{a}{#5\\\hline}%
-      \else\ifx\rev@contextlocal\rev@contextaccept%
-         \textcolor{rev@colortext}{#4}%
-         \rev@noteaccept{#3}{a}%
-      \else\ifx\rev@contextlocal\rev@contextreject%
-         \rev@notereject{#3}{a}%
-      \else%
-         \rev@error{revadd}%
-      \fi\fi\fi%
-   \else%
-      \ifx\rev@contextlocal\rev@contextaccept%
-         #4%
-      \fi%
-   \fi%
-   }
-
-% [#1] context
-% [#2] null
-%  #3  author
-%  #4  old
-%  #5  new
-%  #6  com
-\newcommandtwoopt{\revmod}[6][wait][null]{%
-   \def\rev@contextlocal{#1}%
-   \stepcounter{rev@counter}%
-   \if@rev@see%
-      \ifx\rev@contextlocal\rev@contextwait%
-         \textcolor{rev@colortext}{#5}%
-         \rev@notemark{#3}{c}%
-         \rev@notewait{#3}{c}{#6\\\hline#4\\\hline}%
-      \else\ifx\rev@contextlocal\rev@contextaccept%
-         \textcolor{rev@colortext}{#5}%
-         \rev@noteaccept{#3}{c}%
-      \else\ifx\rev@contextlocal\rev@contextreject%
-         #4%
-         \rev@notereject{#3}{c}%
-      \else%
-         \rev@error{revmod}%
-      \fi\fi\fi%
-   \else%
-      \ifx\rev@contextlocal\rev@contextaccept%
-         #5%
-      \else%
-         #4%
-      \fi%
-   \fi%
-   }
-
-% [#1] context
-% [#2] null
-%  #3  author
-%  #4  old
-%  #5  new
-%  #6  com
-\newcommandtwoopt{\revforget}[6][wait][null]{%
-   \def\rev@contextlocal{#1}%
-   \stepcounter{rev@counter}%
-   \if@rev@see%
-      \ifx\rev@contextlocal\rev@contextwait%
-         \textcolor{rev@colortext}{#5}%
-         \rev@notemark{#3}{f}%
-         \rev@notewait{#3}{f}{#6\\\hline}%
-      \else\ifx\rev@contextlocal\rev@contextaccept%
-         \textcolor{rev@colortext}{#5}%
-         \rev@noteaccept{#3}{f}%
-      \else\ifx\rev@contextlocal\rev@contextreject%
-         #4%
-      \else%
-         \rev@error{revforget}%
-      \fi\fi\fi%
-   \else%
-      \ifx\rev@contextlocal\rev@contextaccept%
-         #5%
-      \else%
-         #4%
-      \fi%
-   \fi%
-   }
-
-% [#1] context
-% [#2] null
-%  #3  author
-%  #4  del
-%  #5  com
-\newcommandtwoopt{\revdel}[5][wait][null]{%
-\def\rev@contextlocal{#1}%
-\stepcounter{rev@counter}%
-\if@rev@see%
-   \ifx\rev@contextlocal\rev@contextwait%
-      \rev@notemark{#3}{d}%
-      \rev@notewait{#3}{d}{#5\\\hline#4\\\hline}%
-   \else\ifx\rev@contextlocal\rev@contextaccept%
-      \rev@noteaccept{#3}{d}%
-   \else\ifx\rev@contextlocal\rev@contextreject%
-      #4%
-   \else%
-      \rev@error{revdel}%
-   \fi\fi\fi%
-\else%
-   \ifx\rev@contextlocal\rev@contextaccept%
-   \else%
-      #4%
-   \fi%
-\fi%
-   }
-
-% [#1] context
-% [#2] null
-%  #3  author
-%  #4  com
-\newcommandtwoopt{\revmark}[4][wait][null]{%
-   \def\rev@contextlocal{#1}%
-   \stepcounter{rev@counter}%
-   \if@rev@see%
-      \ifx\rev@contextlocal\rev@contextwait%
-         \rev@notemark{#3}{m}%
-         \rev@notewait{#3}{m}{\footnotesize#4\\\hline}%
-      \else\ifx\rev@contextlocal\rev@contextaccept%
-         \textcolor{rev@colortext}{#4}%
-         \rev@noteaccept{#3}{m}%
-      \else\ifx\rev@contextlocal\rev@contextreject%
-      \else%
-         \rev@error{revmark}%
-      \fi\fi\fi%
-   \fi%
-   }
-
-% [#1] context
-% [#2] null
-%  #3  author
-%  #4  com
-\newcommandtwoopt{\revpar}[4][wait][null]{%
-   \def\rev@contextlocal{#1}%
-   \stepcounter{rev@counter}%
-   \if@rev@see%
-      \ifx\rev@contextlocal\rev@contextwait%
-%         \rev@notewait{#3}{p}{}%
-%         \textcolor{#3}{$\left<\texttt{\textcolor{rev@colormark}{\therev@counter{p}}}\right.-$}%
-%         \textcolor{rev@colortext}{#4}%
-%         \textcolor{#3}{$-\left.\texttt{\textcolor{rev@colormark}{\therev@counter{p}}}\right>$}%
-%
-%
-         \begin{center}%
-	    \rev@notewait{#3}{p}{}%
-	    \begin{tabular}{|p{0.95\linewidth}|}\hline%
-               \texttt{\textcolor{#3}{\textcolor{rev@colormark}{\therev@counter{p}}-#3}}\\\hline%
-               #4\\\hline%
-            \end{tabular}%
-	 \end{center}%
-%   
-      \else\ifx\rev@contextlocal\rev@contextaccept%
-         \textcolor{rev@colortext}{#4}%
-         \rev@noteaccept{#3}{p}%
-      \else\ifx\rev@contextlocal\rev@contextreject%
-      \else%
-         \rev@error{revpar}%
-      \fi\fi\fi%
-   \fi%
-   }
-
-\endinput